step_lag {recipes} | R Documentation

## Create a lagged predictor

### Description

`step_lag` creates a specification of a recipe step that will add new columns of lagged data. Lagged data will by default include NA values where the lag was induced. These can be removed with `step_naomit()`, or you may specify an alternative filler value with the `default` argument.

### Usage

    step_lag(recipe, ..., role = "predictor", trained = FALSE, lag = 1,
      prefix = "lag_", default = NA, columns = NULL, skip = FALSE,
      id = rand_id("lag"))

### Arguments

`recipe` | A recipe object. The step will be added to the sequence of operations for this recipe.
`...` | One or more selector functions to choose which variables are affected by the step. See `selections()` for more details.
`role` | Defaults to "predictor"
`trained` | A logical to indicate if the quantities for preprocessing have been estimated.
`lag` | A vector of positive integers. Each specified column will be lagged for each value in the vector.
`prefix` | A prefix for generated column names, default to "lag_".
`default` | Passed to `dplyr::lag`, determines what fills empty rows left by lagging (defaults to NA).
`columns` | A character string of variable names that will be populated (eventually) by the `terms` argument.
`skip` | A logical. Should the step be skipped when the recipe is baked by `bake.recipe()`? While all operations are baked when `prep.recipe()` is run, some operations may not be able to be conducted on new data (e.g. processing the outcome variable(s)). Care should be taken when using `skip = TRUE` as it may affect the computations for subsequent operations
`id` | A character string that is unique to this step to identify it.

### Details

The step assumes that the data are already in the proper sequential order for lagging.

### Value

An updated version of `recipe` with the new step added to the sequence of existing steps (if any).

### See Also

`recipe()` `prep.recipe()` `bake.recipe()` `step_naomit()`

### Examples

    n <- 10
    start <- as.Date('1999/01/01')
    end <- as.Date('1999/01/10')

    df <- data.frame(x = runif(n),
                     index = 1:n,
                     day = seq(start, end, by = "day"))

    recipe(~ ., data = df) %>%
      step_lag(index, day, lag = 2:3) %>%
      prep(df) %>%
      bake(df)

[Package recipes version 0.1.5 Index]